



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java 内存区域</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java 内存区域</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-23 02:11:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Java虚拟机锁管理的内存包括以下几个运行时数据区域：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/549074/201402/251443291559885.x-png" /></p>
<p>1、程序计数器：</p>
<p>　　程序计数器是一块较小的内存空间，它的作用可以看做是当前线程所执行的字节码的行号指示器。在虚拟机的概念模型里，字节码解释器工作时就是通过改变这个计数器的值来选取下一条需要执行的字节码指令。</p>
<p>　　java虚拟机的多线程是通过线程轮流切换并分配处理器执行时间的方式来实现的，在任何一个确定的时刻，一个处理器（内核）只会执行一条线程中的指令。因此，为了线程切换后能恢复到正确的执行位置，每条线程都需要有 一个独立的程序计数器，各条线程之间的计数器互不影响，独立存储---<strong>线程私有内存</strong></p>
<p>　　如果线程正在执行一个java方法，这个计数器记录的是正在执行的虚拟机字节码指令的地址，如果正在执行的是Native方法，这个计数器值则为空（Undefined），此内存区域是唯一一个在java虚拟机规范中没有规定任何OutOfMemoryError情况的区域。</p>
<p>2、Java虚拟机栈</p>
<p>　　Java虚拟机栈也是线程私有的，生命周期与线程相同。虚拟机栈描述的是Java方法执行的内存模型：每个方法被执行的时候都会同时创建一个栈帧用于<strong>存储局部变量表、操作栈、动态链接、方法出口等信息</strong>。每个方法被调用直至执行完成的过程，就对应着一个栈帧在虚拟机栈中从入栈到出栈的过程。（stackOverflowError和OutOfMemoryError）</p>
<p>3、本地方法栈</p>
<p>　　与虚拟机栈作用相似，区别是:虚拟机栈为虚拟机执行java方法（也就是字节码）服务，而本地方法栈则是为虚拟机使用到的Native方法服务。（stackOverflowError和OutOfMemoryError）</p>
<p>4、Java堆</p>
<p>　　Java堆是java虚拟机管理的内存最大的一块，被所有线程共享，在虚拟机启动时创建。此内存区域的唯一目的就是存放对象实例，几乎所有的对象实例及数组都在这里分配内存。</p>
<p>　　Java堆是垃圾收集器管理的主要区域，因此很多时候也称GC堆。</p>
<p>　　Java对可以处于物理上不连续的内存空间中，只要逻辑是是连续的即可。（OutOfMemoryError）</p>
<p>5、方法区</p>
<p>　　与java堆一样是线程共享的内存区域，用于存储已被虚拟机加载的类信息、常量、静态变量、即时编译器编译后的代码等数据。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qngj5g8.html">QQ屠龙转世-挖矿</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o376p8.html">python多线程网络编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p65d4q.html">iOS 安装Cocoapods以及安装第三方库的操作流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zd61d9.html">倒戈了，转投简书 --------&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mggo68.html">转：深入理解JavaScript闭包概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnj5lpq.html">关于UIView需要看的一些官方文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xdgyw9.html">poj 3299 Humidex</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y04g3q.html">Html5 Canvas Hit Testing</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojpxzeq.html">&lbrack;Codeforces 873B&rsqb;Balanced Substring</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpzp579.html">【Halum操作-UVA 11478】</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pw5pj8.html">增量会话对象&mdash;&mdash;DeltaSession</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgjg1m8.html">Metasploit学习记录---Nessus安装部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/96004y49.html">安装MySQL时候最后一步报无法定位程序输入点fesetround于动态链接库MSVCR120&period;dll</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyj3lx9.html">关于在CentOS上，绘图丢失部分中文字的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1r10lq.html">OpenGL&mdash;&mdash;旋转的六边形（动画）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv26pz8.html">laravel 使用DB 鏈接leftJoin查詢</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv370l8.html">PHP 字符串两边填充补零</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w5vxzq.html">tp5系统核心设计提供了一些可能会需要的钩子（位置）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4npkpq.html">虚拟机console基础环境部署&mdash;&mdash;工作目录准备</a>
		</li>
						<li><a href="https://www.batexi.com/a/963p3dn9.html">javascript 编辑网页</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mnxjyrq.html">dynamic&lowbar;cast用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x6jyr9.html">在iOS上自动检测内存泄露</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1dmv69.html">hibernate3整合spring2时hibernate即用注解又用配置文件情况时spring配置文件的配置写法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdex5vv9.html">0x800a1391-Microsoft Jscript &amp;quot&semi;JSON未定义&amp;quot&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x6jmn9.html">C&plus;&plus; （P199&mdash;P211）多态 虚函数 抽象类</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y6m4nq.html">Android&lowbar;ProgressBar</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o475j9.html">Java 8 Date Time API Example Tutorial &ndash; LocalDate&comma; Instant&comma; LocalDateTime&comma; Parse and Format</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmx5px9.html">TamperData火狐插件启用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdz02k8.html">关于Eclipse中配置产品启动的插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok2g5e9.html">Java多线程中的join&lpar;&rpar;方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
